package com.orhon.smartcampus.material.modules.management.fetcher;

import com.orhon.smartcampus.material.basicComponents.Result;
import com.orhon.smartcampus.material.modules.base.gqlModel.GQLPageParam;
import com.orhon.smartcampus.material.modules.base.mm.EnvArgsMapper;
import com.orhon.smartcampus.material.modules.management.dao.GoodsClassifyDao;
import com.orhon.smartcampus.material.modules.management.dao.RoomDao;
import com.orhon.smartcampus.material.modules.management.entity.GoodsClassify;
import com.orhon.smartcampus.material.modules.management.entity.RoomEntity;
import com.orhon.smartcampus.material.modules.management.gqlModel.GQLGoodsClassify;
import com.orhon.smartcampus.material.modules.management.gqlModel.RoomGqlModel;
import com.orhon.smartcampus.material.modules.management.mm.GoodsClassifyMapper;
import com.orhon.smartcampus.material.modules.management.mm.RoomMapper;
import com.orhon.smartcampus.material.utils.ObjectToMap;
import com.orhon.smartcampus.material.utils.Util;
import graphql.schema.DataFetcher;
import graphql.schema.DataFetchingEnvironment;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;

@Component
public class SeleRoomListFetcher implements DataFetcher {

    @Autowired
    RoomDao roomDao;

    @Override
    public Object get(DataFetchingEnvironment env) throws Exception {

        // + schoolId
        String hql = "from RoomEntity where 1=1 ";

        GQLPageParam page = EnvArgsMapper.MAPPER.fromArgs(env);

        if(env.containsArgument("condition")) {
            HashMap<String,Object> map = ObjectToMap.to(env.getArgument("condition"));
            if(map.get("id")!=null) {
                hql += " and id " + Util.decide(map.get("id"));
            }
            if(map.get("room_name")!=null) {
                hql += " and room_name " + Util.decide("like_" +map.get("room_name"));
            }
            if(map.get("room_status")!=null) {
                hql += " and room_status " + Util.decide(map.get("room_status"));
            }
        }
        hql += " ORDER BY created_at DESC ";
        List<RoomEntity> list = roomDao.find(hql,null,page.getPage(),page.getLimit());

        List<RoomGqlModel> gqlGoodsClassifies =  RoomMapper.MAPPER.toRoomList(list);
        Long total = 0L;
        if (env.getSelectionSet().contains("total")){
            total = roomDao.getTotalCount(hql);
        }
        return Result.ok().put("data", gqlGoodsClassifies).put("total", total);
    }
}
